## tango 9.4.2+dfsg1

=== CMakeLists.txt ===
# vim: noautoindent:
cmake_minimum_required(VERSION 3.18...3.25 FATAL_ERROR)

project(TangoSourceDistribution LANGUAGES CXX)

include(FindPkgConfig)

# don't let cmake guess file extensions
if(POLICY CMP0115)
    cmake_policy(SET CMP0115 NEW)
endif()

set(SHELL "/usr/bin/env sh")

get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)

if(NOT IS_MULTI_CONFIG AND NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release")
endif()

# switches
option(TSD_LIB "Install and use bundled libtango, if OFF use libtango found on system" ON)
option(TSD_JAVA "Installation of java applications" ON)
option(TSD_DATABASE "Installation of tango database server" ON)
option(TSD_TAC "Installation of access control server" OFF)

# non-boolean knobs
SET(TSD_JAVA_PATH "" CACHE STRING "Path to the java interpreter")
SET(TSD_RC_FILE "/etc/tangorc" CACHE STRING "Path to tango rc file")

if(TSD_JAVA)
  set(JAVA_HOME ${TSD_JAVA_PATH})

  find_package(Java 1.8 COMPONENTS Runtime REQUIRED)

  set(TSD_JAVA_VERSION ${Java_VERSION_STRING})
  set(TSD_JAVA_EXEC ${Java_JAVA_EXECUTABLE})
else()
  set(TSD_JAVA_VERSION "unknown")
  set(TSD_JAVA_EXEC "unknown")
endif()

# Overwrite settings of included projects
option(BUILD_TESTING "Enable building the cppTango tests" OFF)

# The nasty part, overwrite future invocations of pkg-config calls with code
# we are just about to compile and install
pkg_search_module(IDL_PKG tangoidl)
set(IDL_PKG_FOUND ON)
set(IDL_PKG_INCLUDE_DIRS "${CMAKE_CURRENT_SOURCE_DIR}/lib/idl")

add_subdirectory(lib)
if (TSD_LIB)
    list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
endif()

add_subdirectory(cppserver)
add_subdirectory(doc)
add_subdirectory(pogo)

if(TSD_DATABASE)
  add_subdirectory(scripts)
endif()

add_subdirectory(utils)

# mysql/mariadb server is found in TangoDatabase cmake logic

if(OMNIORB_PKG_FOUND)
  set(TSD_OMNIORB_VERSION ${OMNIORB_PKG_VERSION})
  set(TSD_OMNIORB_PATH ${OMNIORB_PKG_PREFIX})
else()
  # TODO Get omniORB version, see https://stackoverflow.com/a/47084079
  # $grep VERSION /usr/include/omniORB4/acconfig.h
  # define PACKAGE_VERSION "4.2.2"
  set(TSD_OMNIORB_VERSION "not-yet-supported")
  set(TSD_OMNIORB_PATH ${TANGO_OMNI_BASE})
endif()

if(ZMQ_PKG_FOUND)
  set(TSD_ZMQ_VERSION ${ZMQ_PKG_VERSION})
  set(TSD_ZMQ_PATH ${ZMQ_PKG_PREFIX})
else()
  # TODO Get ZMQ version
  set(TSD_ZMQ_VERSION "not-yet-supported")
  set(TSD_ZMQ_PATH ${TANGO_ZMQ_BASE})
endif()

# Unfortunately, TangoDatabase's FindMySQL.cmake does not cache MySQL_LIBRARY,
# only MySQL_LIBRARY_RELEASE and MySQL_LIBRARY_DEBUG.
if (NOT MySQL_LIBRARY)
  include(SelectLibraryConfigurations)
  select_library_configurations(MySQL)
endif()

set(TSD_MYSQL_CLIENT_LDLIBS ${MySQL_LIBRARY})
set(TSD_MYSQL_CLIENT_VERSION ${MySQL_VERSION})
set(TSD_MYSQL_SERVER_VERSION ${TDB_DB_VERSION})
set(TSD_MYSQL_SERVER_CONNECTION ${TDB_DB_CONNECTION_RESULT})

message(STATUS                                                                                                               "\
Summary:                                                                                                                   \n \
Configuration (TangoSourceDistribution):                                                                                   \n \
                                                                                                                           \n \
Source code location: ${CMAKE_SOURCE_DIR}                                                                                  \n \
Version: 9.4.2                                                                                                     \n \
Compiler: C++ ${CMAKE_CXX_COMPILER_ID} ${CMAKE_CXX_COMPILER_VERSION}                                                       \n \
                                                                                                                           \n \
OMNIORB PATH: ${TSD_OMNIORB_PATH}                                                                                          \n \
OMNIORB VERSION: ${TSD_OMNIORB_VERSION}                                                                                    \n \
                                                                                                                           \n \
ZMQ PATH: ${TSD_ZMQ_PATH}                                                                                                  \n \
ZMQ VERSION: ${TSD_ZMQ_VERSION}                                                                                            \n \
                                                                                                                           \n \
JAVA PATH: ${TSD_JAVA_EXEC}                                                                                                \n \
JAVA VERSION: ${TSD_JAVA_VERSION}                                                                                          \n \
                                                                                                                           \n \
Database:                                                                                                                  \n \
                                                                                                                           \n \
DB NAME: ${TANGO_DB_NAME}                                                                                                  \n \
CLIENT LIB: ${TSD_MYSQL_CLIENT_LDLIBS}                                                                                     \n \
CLIENT VERSION: ${TSD_MYSQL_CLIENT_VERSION}                                                                                \n \
SERVER VERSION: ${TSD_MYSQL_SERVER_VERSION}                                                                                \n \
CONNECTION: ${TSD_MYSQL_SERVER_CONNECTION}                                                                                 \n \
                                                                                                                           \n \
Build:                                                                                                                     \n \
                                                                                                                           \n \
libraries:              ${TSD_LIB}                                                                                         \n \
java application :      ${TSD_JAVA}                                                                                        \n \
access control server:  ${TSD_TAC}                                                                                         \n \
database server:        ${TSD_DATABASE}                                                                                    \n \
database schema create: ${TDB_DATABASE_SCHEMA}                                                                             \n \
                                                                                                                           \n \
Please check whether the configuration I detected matches what you would like to have.")

=== doc/CMakeLists.txt ===
if (NOT WIN32)
    add_subdirectory(man)
endif()
add_subdirectory(html)

=== cppserver/database/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7...3.22 FATAL_ERROR)

project(DataBase VERSION 5.21.0 LANGUAGES CXX)

# Ensure we have access to MSVC_RUNTIME_LIBRARY property for Windows builds
if (WIN32 AND NOT CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    message(FATAL_ERROR "cmake ${CMAKE_VERSION} is not supported for Windows builds")
endif()

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(configure/CMakeLists.txt)
include(test/CMakeLists.txt)

configure_file(cmake_config.h.in cmake_config.h @ONLY)

set(SOURCES DataBase.cpp
            DataBaseClass.cpp
            DataBaseStateMachine.cpp
            ClassFactory.cpp
            main.cpp)

set(ADDITIONAL_SOURCES  DataBaseUtils.cpp
                        update_starter.cpp)

add_executable(Databaseds ${SOURCES} ${ADDITIONAL_SOURCES})
target_include_directories(Databaseds PUBLIC ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(Databaseds PUBLIC Tango::Tango MySQL::MySQL)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(Databaseds PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

if (MSVC)
    target_compile_options(Databaseds PUBLIC /W3)
else()
    target_compile_options(Databaseds PUBLIC -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1)
endif()


if(CMAKE_CXX_COMPILER_ID MATCHES ".*Clang")
    set_target_properties(Databaseds PROPERTIES LINK_FLAGS "-bind_at_load")
elseif(NOT MSVC)
    target_compile_options(Databaseds PUBLIC -fpie)
    set_target_properties(Databaseds PROPERTIES LINK_FLAGS "-Wl,-z,now -pie")
endif()


if(TDB_ENABLE_COVERAGE)
  target_link_options(Databaseds PUBLIC --coverage)
  target_compile_options(Databaseds PUBLIC --coverage)
endif()

install(TARGETS Databaseds
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
    if (MSVC)
        target_compile_options(Databaseds PUBLIC /WX)
    else()
        target_compile_options(Databaseds PUBLIC -Werror -Wformat -Werror=format-security -pedantic)
    endif()
endif()

=== cppserver/starter/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7...3.22 FATAL_ERROR)
project(Starter VERSION 7.9 LANGUAGES CXX)

# Ensure we have access to MSVC_RUNTIME_LIBRARY property for Windows builds
if (WIN32 AND NOT CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    message(FATAL_ERROR "cmake ${CMAKE_VERSION} is not supported for Windows builds")
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.11)
    get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(IS_MULTI_CONFIG YES)
else()
    set(IS_MULTI_CONFIG NO)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT IS_MULTI_CONFIG)
    message(STATUS "No build type specified - default is DEBUG")
    set(CMAKE_BUILD_TYPE DEBUG)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

set(SOURCES CheckProcessUtil.cpp
            ClassFactory.cpp
            main.cpp
            PingThread.cpp
            Starter.cpp
            StarterClass.cpp
            StarterService.cpp
            StarterStateMachine.cpp
            StarterUtil.cpp
            StartProcessThread.cpp)

set(HEADER CheckProcessUtil.h
           Logging.h
           PingThread.h
           Starter.h
           StarterClass.h
           StarterService.h
           StarterUtil.h)

add_executable(Starter ${SOURCES} ${HEADER})
target_link_libraries(Starter PRIVATE Tango::Tango)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

if (MSVC)
    # Starter requires WIN32 UNICODE string support see
    # https://learn.microsoft.com/en-us/cpp/text/unicode-programming-summary?view=msvc-170
    target_compile_options(Starter PUBLIC /W3 /D_UNICODE)
else()
    target_compile_options(Starter PUBLIC -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1)

    if(NOT (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        target_compile_options(Starter PUBLIC -fpie)
        set_target_properties(Starter PROPERTIES LINK_FLAGS "-Wl,-z,now -pie")
    else()
        set_target_properties(Starter PROPERTIES LINK_FLAGS "-bind_at_load")
    endif()
endif()

install(TARGETS Starter
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

=== cppserver/tangotest/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7...3.22 FATAL_ERROR)

project(TangoTest LANGUAGES CXX
        VERSION 3.0)

# Ensure we have access to MSVC_RUNTIME_LIBRARY property for Windows builds
if (WIN32 AND NOT CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    message(FATAL_ERROR "cmake ${CMAKE_VERSION} is not supported for Windows builds")
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

if(NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()

set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_STANDARD_REQUIRED YES)

set(SOURCES
        ClassFactory.cpp
        TangoTest.cpp
        TangoTestClass.cpp
        TangoTestStateMachine.cpp
        main.cpp)

set(HEADERS
        TangoTest.h
        TangoTestClass.h)

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_link_libraries(${PROJECT_NAME} PRIVATE Tango::Tango)
install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)

if(TANGO_WARNINGS_AS_ERRORS)
  target_compile_options(${PROJECT_NAME} PUBLIC -Werror -Wall -Wextra -Wformat -Werror=format-security -pedantic)
endif()

=== doc/src/requirements.txt ===
Sphinx>=1.6.5
# breathe>=4.6.0
sphinx_rtd_theme

=== lib/cpp/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7 FATAL_ERROR)

# don't let cmake guess file extensions
if(POLICY CMP0115)
    cmake_policy(SET CMP0115 NEW)
endif()

# honour language standards for try_compile
if(POLICY CMP0067)
    cmake_policy(SET CMP0067 NEW)
endif()

project(cppTango)

# omniORB>=4.2.4 is required for compilation in C++17 (or better) mode.
if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

include(CTest)

option(TANGO_WARNINGS_AS_ERRORS "Treat compiler warnings as errors" OFF)
option(BUILD_SHARED_LIBS "Build a shared library instead of static" ON)
option(TANGO_USE_LIBCPP "Build against libc++" OFF)

option(TANGO_USE_PCH "Use precompiled header for include/tango/tango.h" ON)
if (TANGO_USE_PCH AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|MSVC|Clang"))
    message(WARNING "Precompiled headers are not supported for selected compiler.")
    set(TANGO_USE_PCH OFF)
endif()

option(TANGO_ENABLE_COVERAGE "Instrument code for coverage analysis" OFF)
if (TANGO_ENABLE_COVERAGE AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(WARNING "Code coverage is not supported for selected compiler.")
    set(TANGO_ENABLE_COVERAGE OFF)
endif()

set(TANGO_ENABLE_SANITIZER "" CACHE STRING "Enable sanitizer")
set(TANGO_SUPPORTED_SANITIZERS ASAN TSAN UBSAN MSAN)
set_property(CACHE TANGO_ENABLE_SANITIZER PROPERTY STRINGS ${TANGO_SUPPORTED_SANITIZERS})

if(TANGO_ENABLE_SANITIZER AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
    message(FATAL_ERROR "Sanitizers are not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER AND NOT (TANGO_ENABLE_SANITIZER IN_LIST TANGO_SUPPORTED_SANITIZERS))
    message(FATAL_ERROR "TANGO_ENABLE_SANITIZER must be one of: ${TANGO_SUPPORTED_SANITIZERS}.")
endif()
if(TANGO_ENABLE_SANITIZER STREQUAL "MSAN" AND CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
    message(FATAL_ERROR "MSAN is not supported for selected compiler.")
endif()
if(TANGO_ENABLE_SANITIZER)
    find_program(ADDR2LINE_PROGRAM "addr2line")
    find_program(LLVM_SYMBOLIZER_PROGRAM "llvm-symbolizer")
    if(NOT ADDR2LINE_PROGRAM)
        message(FATAL_ERROR "Could not find addr2line (required for sanitizers).")
    endif()
    if(NOT LLVM_SYMBOLIZER_PROGRAM AND CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        message(FATAL_ERROR "Could not find llvm-symbolizer (required for sanitizers).")
    endif()
endif()

#need to define the version of the library
set(MAJOR_VERSION "9")
set(MINOR_VERSION "4")
set(PATCH_VERSION "2")

if(WIN32)
    include(configure/cmake_win_defs.cmake)
    include(configure/cmake_pch_win.cmake)
else()
    include(configure/cmake_pch_linux.cmake)
endif()

#convenient versions
set(LIBRARY_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${PATCH_VERSION}")
set(SO_VERSION "${MAJOR_VERSION}${MINOR_VERSION}")

set(TANGO_HOST $ENV{TANGO_HOST})
include(configure/CMakeLists.txt)

SET(BUILD_TANGO_LOCAL_INCLUDE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/cppapi/include)
message(STATUS "Using ${BUILD_TANGO_LOCAL_INCLUDE_DIR} as build-time include directory")
include_directories(${BUILD_TANGO_LOCAL_INCLUDE_DIR})
include_directories(log4tango/include)
#required for generated include/tango/idl/tango.h, include/tango/common/tango_const.h and config.h
include_directories(${CMAKE_CURRENT_BINARY_DIR}/cppapi/include)
include_directories(${CMAKE_CURRENT_BINARY_DIR}/log4tango/include)

#source code
add_subdirectory("log4tango")
add_subdirectory("cppapi")

if(BUILD_TESTING)

  find_program(DOCKER_BINARY docker)
  if(NOT DOCKER_BINARY)
      message(WARNING "The tests can not be run as docker is missing.")
  endif()

  if(BUILD_SHARED_LIBS)
    add_subdirectory("tests")
  else()
    message(WARNING "Not building the tests, because that is currently supported only when BUILD_SHARED_LIBS is ON")
    set(BUILD_TESTING OFF)
  endif()
endif()

if(WIN32)
    include(configure/cmake_win.cmake)
    include(configure/cpack_win.cmake)
else()
    include(configure/cmake_linux.cmake)
endif()

include(CPack)

=== lib/java/CMakeLists.txt ===
project(java)

include(GNUInstallDirs)

find_package(Doxygen)
if(Doxygen_FOUND)
  set(DOXYGEN ${DOXYGEN_EXECUTABLE})
else()
  message(STATUS "Doxygen could not be found, pogo will therefore not be able to generate documentation")
endif()

if (NOT WIN32)
    set(SHELL_SCRIPTS astor
                    jive
                    pogo
                    atkpanel
                    logviewer
                    atktuning
                    jdraw
                    synopticappli
                    atkmoni
                    tg_devtest
                    TangoVers
                    TangoRestServer)

    foreach(input ${SHELL_SCRIPTS})
        configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${input}.in ${input} @ONLY)
        install(PROGRAMS ${CMAKE_CURRENT_BINARY_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
else()
    set(BATCH_SCRIPTS
        start-astor.bat
        start-atkmoni.bat
        start-atkpanel.bat
        start-atktuning.bat
        start-jdraw.bat
        start-jive.bat
        start-logviewer.bat
        start-pogo.bat
        start-synoptic.bat
        atktuning_attributes.txt)

    foreach(input ${BATCH_SCRIPTS})
        install(PROGRAMS ${CMAKE_CURRENT_SOURCE_DIR}/${input}
                DESTINATION ${CMAKE_INSTALL_BINDIR})
    endforeach()
endif()

set(CONFIG_XML logback-server.xml
               logback.xml)

foreach(input ${CONFIG_XML})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/tango)
endforeach()

# the following list of filenames is replaced with the real names by
# prepare-assets in build.xml, see also https://ant.apache.org/manual/Types/filterset.html
set(JAR_FILES Astor-7.4.4.jar
              ATKCore-9.3.28.jar
              ATKPanel-5.11.jar
              ATKTuning-4.8.jar
              ATKWidget-9.3.28.jar
              DBBench-1.4.jar
              Jive-7.36.jar
              JSSHTerminal-1.18.jar
              JTango-9.6.6.jar
              LogViewer-2.1.1.jar
              Pogo-9.8.0.jar)
if (NOT WIN32) 
    list(APPEND JAR_FILES RestServer-1.22.jar)
endif()

foreach(input ${JAR_FILES})
  string(REGEX REPLACE "^([^-]+)-.*(\.jar)$" "\\1\\2" output ${input})
  install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/${input}
          RENAME ${output}
          DESTINATION ${CMAKE_INSTALL_DATADIR}/java)
endforeach()

=== utils/tango_admin/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7 FATAL_ERROR)

project(tango_admin VERSION 1.18 LANGUAGES CXX)

if (NOT DEFINED CMAKE_CXX_STANDARD)
    set(CMAKE_CXX_STANDARD 14)
endif()
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

set(SOURCES
        tango_admin.cpp
        anyoption.cpp)

set(HEADERS
        anyoption.h)

add_executable(${PROJECT_NAME} ${SOURCES} ${HEADERS})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})
target_link_libraries(${PROJECT_NAME} PUBLIC Tango::Tango ${CMAKE_DL_LIBS})

install(TARGETS ${PROJECT_NAME} RUNTIME DESTINATION bin)

=== cppserver/database/configure/CMakeLists.txt ===
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

include(GNUInstallDirs)
find_package(MySQL REQUIRED OPTIONAL_COMPONENTS exe)
find_package(Tango REQUIRED)

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.11)
  get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
  set(IS_MULTI_CONFIG YES)
else()
  set(IS_MULTI_CONFIG NO)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT IS_MULTI_CONFIG)
  message(STATUS "No build type specified - default is DEBUG")
  set(CMAKE_BUILD_TYPE DEBUG)
endif()

option(BUILD_TESTING "Build tests" OFF)
include(CTest)
if (BUILD_TESTING AND WIN32)
  message(WARNING "BUILD_TESTING not supported on Windows.  Forcing OFF")
  set(BUILD_TESTING OFF)
endif()

option(TDB_DATABASE_SCHEMA "Create the tango database schema" OFF)
if (TDB_DATABASE_SCHEMA AND WIN32)
  message(WARNING "TDB_DATABASE_SCHEMA not supported on Windows.  Forcing OFF")
  set(TDB_DATABASE_SCHEMA OFF)
endif()

set(MYSQL_ADMIN "" CACHE STRING "Database user")
set(MYSQL_ADMIN_PASSWD "" CACHE STRING "Database user password")
set(MYSQL_HOST "localhost" CACHE STRING "Database server host")

if(BUILD_TESTING)
  set(TANGO_DB_NAME tango_database_ci CACHE STRING "Name of the tango database" FORCE)
  message(STATUS "Forcing TANGO_DB_NAME to ${TANGO_DB_NAME} for testing")
else()
  set(TANGO_DB_NAME tango CACHE STRING "Name of the tango database")
endif()

if(NOT MYSQL)
  if(MySQL_exe_FOUND)
    message(STATUS "No MySQL client program specified using -DMYSQL - default is ${MySQL_EXECUTABLE}")
    set(MYSQL ${MySQL_EXECUTABLE})
  else()
    message(STATUS "No MySQL client program specified using -DMYSQL and we could not find one.\nDatabase schema creation will not possible.")
    set(TDB_DATABASE_SCHEMA FALSE)
 endif()
endif()

if(BUILD_TESTING AND (NOT MYSQL_ADMIN OR NOT MYSQL_ADMIN_PASSWD))
  message(FATAL_ERROR "For building and running the tests you have to supply both MYSQL_ADMIN and MYSQL_ADMIN_PASSWD.")
endif()

option(TDB_ENABLE_COVERAGE "Instrument code for coverage analysis" OFF)
if(TDB_ENABLE_COVERAGE AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU|Clang"))
  message(WARNING "TDB_ENABLE_COVERAGE is not supported for selected compiler ${CMAKE_CXX_COMPILER_ID}. Forcing OFF")
  set(TDB_ENABLE_COVERAGE OFF)
endif()

set(DB_SCRIPTS create_db.sql
               create_db_tables.sql
               rem_history.sql
               stored_proc.sql
               update_db_from_5_to_9.3.4.sql
               update_db_from_6_to_9.3.4.sql
               update_db_from_7_to_9.3.4.sql
               update_db_from_8_to_9.3.4.sql
               update_db_from_9.2.5_to_9.3.4.sql
               update_db.sql)

if (NOT WIN32)
    set(DB_SCRIPTS ${DB_SCRIPTS} create_db.sh update_db.sh)
endif()

foreach(DB_SCRIPT_FILE ${DB_SCRIPTS})
  if (EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/${DB_SCRIPT_FILE}.in)
    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/${DB_SCRIPT_FILE}.in
      ${CMAKE_CURRENT_BINARY_DIR}/${DB_SCRIPT_FILE})
    install(FILES ${CMAKE_CURRENT_BINARY_DIR}/${DB_SCRIPT_FILE}
      DESTINATION "${CMAKE_INSTALL_DATADIR}/tango/db")
  endif()
endforeach(DB_SCRIPT_FILE)

if (WIN32)
  install(
    FILES
      ${CMAKE_CURRENT_SOURCE_DIR}/create_db.bat
      ${CMAKE_CURRENT_SOURCE_DIR}/update_db.bat
    DESTINATION
    "${CMAKE_INSTALL_DATADIR}/tango/db")
endif()

if(MYSQL)
  execute_process(COMMAND ${MYSQL} "--execute=SELECT * FROM ENGINES;" --user=${MYSQL_ADMIN} --password=${MYSQL_ADMIN_PASSWD} --host=${MYSQL_HOST} information_schema
                  RESULT_VARIABLE DB_CONNECTION_RESULT
                  OUTPUT_VARIABLE DB_CONNECTION_CHECK_OUTPUT
                  ERROR_VARIABLE DB_CONNECTION_CHECK_ERROR)

  if(NOT DB_CONNECTION_RESULT EQUAL 0)
    message(WARNING "DB Connection check failed with: ${DB_CONNECTION_CHECK_ERROR}")
  else()
    message(STATUS "DB Connection check was successfull")
  endif()

  execute_process(COMMAND ${MYSQL} "--execute=SELECT VERSION();" --user=${MYSQL_ADMIN} --password=${MYSQL_ADMIN_PASSWD} --host=${MYSQL_HOST} information_schema
                  RESULT_VARIABLE DB_VERSION_RESULT
                  OUTPUT_VARIABLE DB_VERSION_CHECK_OUTPUT
                  ERROR_VARIABLE DB_VERSION_CHECK_ERROR)

  if(NOT DB_VERSION_RESULT EQUAL 0)
    message(WARNING "DB version check failed with: ${DB_VERSION_CHECK_ERROR}")
  else()
    message(STATUS "DB version check was successfull")
  endif()

  if(TDB_DATABASE_SCHEMA)
    execute_process(COMMAND ${CMAKE_CURRENT_BINARY_DIR}/create_db.sh
                    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
                    RESULT_VARIABLE DB_CREATE_SCHEMA_RESULT
                    OUTPUT_VARIABLE DB_CREATE_SCHEMA_OUTPUT
                    ERROR_VARIABLE DB_CREATE_SCHEMA_ERROR)

    if(NOT DB_CREATE_SCHEMA_RESULT EQUAL 0)
      message(FATAL_ERROR "DB schema creation failed with: ${DB_CREATE_SCHEMA_ERROR}")
    else()
      message(STATUS "DB schema creation was successfull.")
    endif()
  endif()
else()
  set(DB_CONNECTION_RESULT 1)
  set(DB_VERSION_RESULT 1)
endif()

# From https://stackoverflow.com/a/41773727
function(invert varName varValue)
  if(${varValue})
    set(${varName} FALSE PARENT_SCOPE)
  else()
    set(${varName} TRUE PARENT_SCOPE)
  endif()
endfunction()

invert("DB_CONNECTION_RESULT" ${DB_CONNECTION_RESULT})
set(TDB_DB_CONNECTION_RESULT ${DB_CONNECTION_RESULT} CACHE INTERNAL "Result of the database connection test")

if(DB_VERSION_RESULT EQUAL 0)
  string(REPLACE "VERSION()" "" DB_VERSION_CHECK_OUTPUT ${DB_VERSION_CHECK_OUTPUT})
  string(STRIP ${DB_VERSION_CHECK_OUTPUT} DB_VERSION_CHECK_OUTPUT)
  set(TDB_DB_VERSION ${DB_VERSION_CHECK_OUTPUT} CACHE INTERNAL "Database server version")
else()
  set(TDB_DB_VERSION "unknown" CACHE INTERNAL "Database server version")
endif()

=== cppserver/tangoaccesscontrol/TangoAccessControl/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7...3.22 FATAL_ERROR)
project(TangoAccessControl VERSION 2.19 LANGUAGES CXX)

# Ensure we have access to MSVC_RUNTIME_LIBRARY property for Windows builds
if (WIN32 AND NOT CMAKE_VERSION VERSION_GREATER_EQUAL 3.15)
    message(FATAL_ERROR "cmake ${CMAKE_VERSION} is not supported for Windows builds")
endif()

if (CMAKE_VERSION VERSION_GREATER_EQUAL 3.11)
    get_property(IS_MULTI_CONFIG GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
elseif(CMAKE_CONFIGURATION_TYPES)
    set(IS_MULTI_CONFIG YES)
else()
    set(IS_MULTI_CONFIG NO)
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT IS_MULTI_CONFIG)
    message(STATUS "No build type specified - default is DEBUG")
    set(CMAKE_BUILD_TYPE DEBUG)
endif()

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(MySQL REQUIRED)
find_package(Tango REQUIRED)

set(SOURCES ClassFactory.cpp
            DbUtils.cpp
            TangoAccessControlStateMachine.cpp
            TangoAccessControl.cpp
            TangoAccessControlClass.cpp
            main.cpp)

set(ADDITIONAL_SOURCES ../AbstractClasses/AccessControl.cpp
                       ../AbstractClasses/AccessControlClass.cpp
                       ../AbstractClasses/AccessControlStateMachine.cpp)

set(HEADERS Logging.h
            TangoAccessControl.h
            TangoAccessControlClass.h)

set(ADDITIONAL_HEADERS ../AbstractClasses/AccessControl.h
                       ../AbstractClasses/AccessControlClass.h)

add_executable(TangoAccessControl ${SOURCES} ${ADDITIONAL_SOURCES} ${HEADERS} ${ADDITIONAL_HEADERS})
target_link_libraries(TangoAccessControl PUBLIC Tango::Tango MySQL::MySQL)
target_include_directories(TangoAccessControl PUBLIC ../AbstractClasses)

if (WIN32 AND (Tango_IS_STATIC OR Tango_FORCE_STATIC))
    set_target_properties(${PROJECT_NAME} PROPERTIES
        MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>"
    )
endif()


if (MSVC)
    target_compile_options(TangoAccessControl PUBLIC /W3)
else()
    target_compile_options(TangoAccessControl PUBLIC -Wall -Wextra -D_FORTIFY_SOURCE=2 -O1)

    if(NOT (CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
        target_compile_options(TangoAccessControl PUBLIC -fpie)
        set_target_properties(TangoAccessControl PROPERTIES LINK_FLAGS "-Wl,-z,now -pie")
    else()
        set_target_properties(TangoAccessControl PROPERTIES LINK_FLAGS "-bind_at_load")
    endif()
endif()

install(TARGETS TangoAccessControl
        RUNTIME DESTINATION "${CMAKE_INSTALL_FULL_BINDIR}")

=== lib/cpp/configure/CMakeLists.txt ===
include(FindPkgConfig)
include(GNUInstallDirs)

option(TANGO_USE_JPEG "Build jpeg support" ON)

if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

if(WIN32)
  set(WINDOWS_SUPPORTED_VS_TOOLSETS v141 v142 v143)
endif()

#assuming build platform == target
set(PLATFORM 32)
if(WIN32)
    if(CMAKE_CL_64)
        set(PLATFORM 64)
    endif()
else()
    if(${CMAKE_SIZEOF_VOID_P} EQUAL 8)
        set(PLATFORM 64)
    endif()
endif()

message(STATUS "CMake: version ${CMAKE_VERSION}")
message(STATUS "Target platform: ${CMAKE_SYSTEM_NAME} ${PLATFORM}-bit")
message(STATUS "C++ Compiler: ${CMAKE_CXX_COMPILER_ID} with version ${CMAKE_CXX_COMPILER_VERSION}")
message(STATUS "C Compiler: ${CMAKE_C_COMPILER_ID} with version ${CMAKE_C_COMPILER_VERSION}")
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
message(STATUS "Environment: TANGO_HOST=$ENV{TANGO_HOST}")

if(TANGO_CPPZMQ_BASE)
    message("Using TANGO_CPPZMQ_BASE=${TANGO_CPPZMQ_BASE}")
    set(CPPZMQ_PKG_INCLUDE_DIRS ${TANGO_CPPZMQ_BASE}/include)
endif()

if(TANGO_IDL_BASE)
    message("Using TANGO_IDL_BASE=${TANGO_IDL_BASE}")
    set(IDL_PKG_INCLUDE_DIRS ${TANGO_IDL_BASE}/include)
else()
    pkg_search_module(IDL_PKG REQUIRED tangoidl)
endif()

if(TANGO_OMNI_BASE)
    message("Using TANGO_OMNI_BASE=${TANGO_OMNI_BASE}")
    set(OMNIORB_PKG_INCLUDE_DIRS ${TANGO_OMNI_BASE}/include)
    if(WIN32)
        set(OMNIIDL_PATH ${TANGO_OMNI_BASE}/bin/x86_win32/)
        set(OMNIORB_PKG_LIBRARY_DIRS ${TANGO_OMNI_BASE}/lib/x86_win32)
        set(OMNIORB_PKG_LIBRARIES_DYN_DEBUG "omniORB4_rtd.lib;omniDynamic4_rtd.lib;omnithread_rtd.lib;COS4_rtd.lib")
        set(OMNIORB_PKG_LIBRARIES_STA_DEBUG "omniORB4d.lib;omniDynamic4d.lib;omnithreadd.lib;COS4d.lib")
        set(OMNIORB_PKG_LIBRARIES_DYN_RELEASE "omniORB4_rt.lib;omniDynamic4_rt.lib;omnithread_rt.lib;COS4_rt.lib")
        set(OMNIORB_PKG_LIBRARIES_STA_RELEASE "omniORB4.lib;omniDynamic4.lib;omnithread.lib;COS4.lib")
        if (CMAKE_BUILD_TYPE STREQUAL "Debug")
            set(OMNIORB_PKG_LIBRARIES_DYN ${OMNIORB_PKG_LIBRARIES_DYN_DEBUG})
            set(OMNIORB_PKG_LIBRARIES_STA ${OMNIORB_PKG_LIBRARIES_STA_DEBUG})
        else()
            set(OMNIORB_PKG_LIBRARIES_DYN ${OMNIORB_PKG_LIBRARIES_DYN_RELEASE})
            set(OMNIORB_PKG_LIBRARIES_STA ${OMNIORB_PKG_LIBRARIES_STA_RELEASE})
        endif()
    else()
        set(OMNIIDL_PATH ${TANGO_OMNI_BASE}/bin/)
        set(OMNIORB_PKG_LIBRARY_DIRS ${TANGO_OMNI_BASE}/lib)
        set(OMNIORB_PKG_LIBRARIES "-lomniORB4 -lomnithread -lCOS4 -lomniDynamic4")
    endif()
    link_directories(${OMNIORB_PKG_LIBRARY_DIRS})

    find_program(OMNIIDL NAMES omniidl
                         HINTS ${OMNIIDL_PATH} ${TANGO_OMNIIDL_PATH}
                         DOC "omniidl executable location"
                         NO_DEFAULT_PATH)
    mark_as_advanced(OMNIIDL)

else()
    #CORBA
    pkg_search_module(OMNIORB_PKG REQUIRED omniORB4)
    pkg_get_variable(OMNIIDL omniORB4 omniidl)
    set(OMNIIDL "${OMNIIDL}" CACHE FILEPATH "omniidl executable location")
    mark_as_advanced(OMNIIDL)

    #COS
    pkg_search_module(OMNICOS_PKG REQUIRED omniCOS4)
    #dynamic CORBA
    pkg_search_module(OMNIDYN_PKG REQUIRED omniDynamic4)

    link_directories(${OMNIORB_PKG_LIBRARY_DIRS})
endif()

if(NOT OMNIIDL)
  message(FATAL_ERROR "Could not find a usable omniidl")
endif()

function(tango_find_omniorb_version)
    if (DEFINED OMNIORB_PKG_VERSION)
        set(version ${OMNIORB_PKG_VERSION})
    else()
        find_file(acconfig
            NAMES omniORB4/acconfig.h
            PATHS ${OMNIORB_PKG_INCLUDE_DIRS}
            NO_DEFAULT_PATH
            )

        if (NOT acconfig)
            message(WARNING "Could not find omniORB4/acconfig.h")
            set(OMNIORB_VERSION OMNIORB_VERSION-NOTFOUND PARENT_SCOPE)
            return()
        endif()

        file(STRINGS ${acconfig} version_info
            REGEX "^#define[ \t]+PACKAGE_VERSION.*$")
        list(LENGTH version_info version_info_length)

        if (NOT version_info_length EQUAL 1)
            message(WARNING "Could not find version information in ${acconfig}")
            set(OMNIORB_VERSION OMNIORB_VERSION-NOTFOUND PARENT_SCOPE)
            return()
        endif()

        string(REGEX REPLACE "^#define[ \t]+PACKAGE_VERSION[ \t]+\"(([0-9]+\\.?)+)\"" "\\1" version ${version_info})
    endif()

    set(OMNIORB_VERSION ${version} CACHE STRING "omniORB version")
    mark_as_advanced(OMNIORB_VERSION)
endfunction()

if (NOT DEFINED OMNIORB_VERSION)
    tango_find_omniorb_version()
endif()

# These define a semi-open "[min, max)" range of allowed omniORB versions
set(OMNIORB_VERSION_MINIMUM 4.2.2) # See cppTango#1013
set(OMNIORB_VERSION_MAXIMUM 4.3.0) # See cppTango#760

if (OMNIORB_VERSION)
    if (OMNIORB_VERSION VERSION_LESS OMNIORB_VERSION_MINIMUM OR
        OMNIORB_VERSION VERSION_GREATER_EQUAL OMNIORB_VERSION_MAXIMUM)
        message(FATAL_ERROR "Found omniORB version (${OMNIORB_VERSION}) outside of allowed range [${OMNIORB_VERSION_MINIMUM}, ${OMNIORB_VERSION_MAXIMUM})")
    endif()
    message(STATUS "Found OMNIORB_VERSION=${OMNIORB_VERSION}")
else()
    message(WARNING "omniORB version not found")
endif()

include(configure/find_and_check_omniidl.cmake)

if(TANGO_ZMQ_BASE)
    message("Using TANGO_ZMQ_BASE=${TANGO_ZMQ_BASE}")
    set(ZMQ_PKG_INCLUDE_DIRS ${TANGO_ZMQ_BASE}/include)
    if (WIN32)
        link_directories(${TANGO_ZMQ_BASE}/lib/Debug)
        link_directories(${TANGO_ZMQ_BASE}/lib/Release)
        link_directories(${TANGO_ZMQ_BASE}/bin/Debug)
        link_directories(${TANGO_ZMQ_BASE}/bin/Release)
        if(CMAKE_VS_PLATFORM_TOOLSET IN_LIST WINDOWS_SUPPORTED_VS_TOOLSETS)
            if(CMAKE_BUILD_TYPE STREQUAL "Debug")
                set(ZMQ_PKG_LIBRARIES_STA "libzmq-v141-mt-sgd-4_0_5.lib")
                set(ZMQ_PKG_LIBRARIES_DYN "libzmq-v141-mt-gd-4_0_5.lib")
            else()
                set(ZMQ_PKG_LIBRARIES_STA "libzmq-v141-mt-s-4_0_5.lib")
                set(ZMQ_PKG_LIBRARIES_DYN "libzmq-v141-mt-4_0_5.lib")
            endif()
        endif()
    else()
        set(ZMQ_PKG_LIBRARIES "-lzmq")
        set(ZMQ_PKG_LIBRARY_DIRS ${TANGO_ZMQ_BASE}/lib)
        link_directories(${ZMQ_PKG_LIBRARY_DIRS})
    endif()
else()
    pkg_search_module(ZMQ_PKG REQUIRED libzmq)

    # libzmq 4.0.5 does not set ZMQ_PKG_LIBRARY_DIRS only newer versions set
    # this in addition to ZMQ_PKG_LIBDIR
    if(ZMQ_PKG_LIBRARY_DIRS STREQUAL "")
      set(ZMQ_PKG_LIBRARY_DIRS "${ZMQ_PKG_LIBDIR}")
    endif()

    # fedora 37 only sets ZMQ_PKG_INCLUDEDIR
    if(ZMQ_PKG_INCLUDE_DIRS STREQUAL "")
      set(ZMQ_PKG_INCLUDE_DIRS "${ZMQ_PKG_INCLUDEDIR}")
    endif()

    link_directories(${ZMQ_PKG_LIBRARY_DIRS})
endif()

# Check for jpeg support
if(TANGO_USE_JPEG)
    if(TANGO_JPEG_BASE)
        message("Using TANGO_JPEG_BASE=${TANGO_JPEG_BASE}")
        set(JPEG_PKG_INCLUDE_DIRS ${TANGO_JPEG_BASE}/include)
        link_directories(${TANGO_JPEG_BASE}/lib)
        if (WIN32)
            if(CMAKE_BUILD_TYPE STREQUAL "Debug")
                set(JPEG_PKG_LIBRARIES_STA "jpeg-static${JPEG_DEBUG_POSTFIX}.lib")
                set(JPEG_PKG_LIBRARIES_DYN "jpeg${JPEG_DEBUG_POSTFIX}.lib")
            else()
                set(JPEG_PKG_LIBRARIES_STA "jpeg-static.lib")
                set(JPEG_PKG_LIBRARIES_DYN "jpeg.lib")
            endif()
        else()
            set(JPEG_PKG_LIBRARIES "-ljpeg")
        endif()
    else()
      find_package(JPEG)

      if(JPEG_FOUND)
        set(JPEG_PKG_LIBRARIES "${JPEG_LIBRARIES}")
        set(JPEG_PKG_LIBRARY_DIRS "${JPEG_LIBRARY_DIRS}")
        set(JPEG_PKG_CFLAGS_OTHER "${JPEG_CFLAGS_OTHER}")
      else()
        pkg_search_module(JPEG_PKG REQUIRED libjpeg)
      endif()

      link_directories(${JPEG_PKG_LIBRARY_DIRS})
    endif()
    # Set variables for substitution in the pkg-config file
    set(JPEG_LIB libjpeg)
    set(JPEG_LIB_FLAG -ljpeg)
endif()

if(PTHREAD_WIN)
    message("Using PTHREAD_WIN=${PTHREAD_WIN}")
    add_definitions(-DHAVE_PTHREAD_NP_H)
    set(PTHREAD_WIN_PKG_INCLUDE_DIRS ${PTHREAD_WIN}/include)
    link_directories(${PTHREAD_WIN}/lib)
    link_directories(${PTHREAD_WIN}/bin)

    if (CMAKE_BUILD_TYPE STREQUAL "Debug")
        set(PTHREAD_WIN_PKG_LIBRARIES_DYN "pthreadVC2d.lib")
        set(PTHREAD_WIN_PKG_LIBRARIES_STA "pthreadVC2-sd.lib")
    else()
        set(PTHREAD_WIN_PKG_LIBRARIES_DYN "pthreadVC2.lib")
        set(PTHREAD_WIN_PKG_LIBRARIES_STA "pthreadVC2-s.lib")
    endif()
endif()

if(NOT WIN32)
  if(NOT DEFINED TANGO_CPPZMQ_USABLE_VERSION)
    try_compile(TANGO_CPPZMQ_USABLE_VERSION ${CMAKE_CURRENT_BINARY_DIR}/test_cppzmq_features
                SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/configure/test_cppzmq_features.cpp
                CMAKE_FLAGS "-DLINK_DIRECTORIES=${ZMQ_PKG_LIBRARY_DIRS}"
                COMPILE_DEFINITIONS "-I ${CPPZMQ_PKG_INCLUDE_DIRS} -I ${ZMQ_PKG_INCLUDE_DIRS}"
                LINK_LIBRARIES "${ZMQ_PKG_LIBRARIES}"
                OUTPUT_VARIABLE CPPZMQ_TRY_COMPILE_OUTPUT)
  endif()

  set(msg "Check if cppzmq is present and recent enough: ${TANGO_CPPZMQ_USABLE_VERSION}")

  if(${TANGO_CPPZMQ_USABLE_VERSION})
    message(STATUS ${msg})
  else()
    message(FATAL_ERROR ${msg} "\n\nBuild output:\n" ${CPPZMQ_TRY_COMPILE_OUTPUT})
  endif()

  set(ZMQ_MIN_VER_MAJOR 4)
  set(ZMQ_MIN_VER_MINOR 0)
  set(ZMQ_MIN_VER_PATCH 5)

  if(NOT DEFINED TANGO_ZMQ_USABLE_VERSION)
    try_compile(TANGO_ZMQ_USABLE_VERSION ${CMAKE_CURRENT_BINARY_DIR}/test_zmq_version
                SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/configure/test_zmq_version.cpp
                COMPILE_DEFINITIONS "-I ${ZMQ_PKG_INCLUDE_DIRS}
                -DMINIMUM_VERSION_MAJOR=${ZMQ_MIN_VER_MAJOR}
                -DMINIMUM_VERSION_MINOR=${ZMQ_MIN_VER_MINOR}
                -DMINIMUM_VERSION_PATCH=${ZMQ_MIN_VER_PATCH}"
                CMAKE_FLAGS "-DLINK_DIRECTORIES=${ZMQ_PKG_LIBRARY_DIRS}"
                LINK_LIBRARIES "${ZMQ_PKG_LIBRARIES}"
                OUTPUT_VARIABLE ZMQ_TRY_COMPILE_OUTPUT)
  endif()

  set(msg "Check if libzmq version is >= ${ZMQ_MIN_VER_MAJOR}.${ZMQ_MIN_VER_MINOR}.${ZMQ_MIN_VER_PATCH}: ${TANGO_ZMQ_USABLE_VERSION}")

  if(${TANGO_ZMQ_USABLE_VERSION})
    message(STATUS ${msg})
  else()
    message(FATAL_ERROR ${msg} "\n\nBuild output:\n" ${ZMQ_TRY_COMPILE_OUTPUT})
  endif()
endif()

if(NOT WIN32)
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU" OR CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
      if(CMAKE_BUILD_TYPE MATCHES "(Release|RelWithDebInfo|MinSizeRel)")
            add_definitions(-D_FORTIFY_SOURCE=2)
            add_compile_options(-fstack-protector-strong)
      elseif(CMAKE_BUILD_TYPE STREQUAL "Debug")
          add_compile_options(-Wall -Wextra -Wformat -Werror=format-security -pedantic -Og -g)
      else()
          message(FATAL_ERROR "Invalid CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
      endif()

        if(TANGO_ENABLE_SANITIZER STREQUAL "ASAN")
            add_compile_options(-fsanitize=address -fsanitize=leak
                -fno-omit-frame-pointer
                -Og -g)
            add_link_options(-fsanitize=address -fsanitize=leak)
        elseif(TANGO_ENABLE_SANITIZER STREQUAL "TSAN")
            add_compile_options(-fsanitize=thread -Og -g)
            add_link_options(-fsanitize=thread)
        elseif(TANGO_ENABLE_SANITIZER STREQUAL "UBSAN")
            add_compile_options(-fsanitize=undefined
                -fno-omit-frame-pointer
                -Og -g)
            add_link_options(-fsanitize=undefined)
            if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
                add_compile_options(
                    -fsanitize=implicit-integer-truncation
                    -fsanitize=implicit-integer-arithmetic-value-change
                    -fsanitize=implicit-conversion
                    -fsanitize=integer
                    -fsanitize=nullability)
            endif()
        elseif(TANGO_ENABLE_SANITIZER STREQUAL "MSAN")
            add_compile_options(-fsanitize=memory
                -fno-omit-frame-pointer

=== debian/changelog ===
tango (9.4.2+dfsg1-1) unstable; urgency=low

  * Team Upload

  * New upstream version 9.4.2+dfsg1
  * Remove RELEASE: experimental in d/gitlab-ci.yml
  * Update Files-Excluded in d/copyright
  * Add d/patches/set-default-date-current_date-table-script.patch
  * Initial systemd support (Closes: #1039389). Thanks to Picca
    Frédéric-Emmanuel for the review!
  * Comment out Suggests: omninotify in tango-starter. omninotify is not found in debian
  * Add initial d/test/starter-basic autopkgtest

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 10 Aug 2023 13:40:09 -0300

=== debian/control ===
Source: tango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Picca Frédéric-Emmanuel <picca@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
               default-libmysqlclient-dev,
               libcos4-dev,
               libjpeg-dev,
               cppzmq-dev,
               omniidl,
               po-debconf
Build-Depends-Indep: doxygen,
                     python3-ipython,
                     python3-sphinx,
                     python3-sphinx-rtd-theme
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/science-team/tango
Vcs-Git: https://salsa.debian.org/science-team/tango.git
Homepage: https://www.tango-controls.org
Rules-Requires-Root: no

# according to the convention, this package should have to be called
# libtango94. cpptango 9.4.x is not backwards compatible with 9.3.x. The
# SONAME should have to be increased but upstream has decided to don't use
# libtango10.so because it could mislead users about a non-CORBA-dependent
# Tango version. To avoid conflicts with a possible future tango 94.x version,
# this package is called libtango9-4
Package: libtango9-4
Architecture: any
Multi-Arch: same
Section: libs
Depends: tango-common,
         ${misc:Depends},
         ${shlibs:Depends}
Description: TANGO distributed control system - shared library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the files necessary for running TANGO applications.

Package: libtango-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libcos4-dev,
         libtango9-4 (= ${binary:Version}),
         cppzmq-dev,
         libjpeg-dev,
         ${misc:Depends}
Conflicts: libtango7-dev, libtango8-dev
Description: TANGO distributed control system - development library
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the tango9 development files.

Package: libtango-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends}
Description: TANGO distributed control system - documentation
 TANGO is an object-oriented distributed control system using CORBA. In
 TANGO all objects are representations of devices, which can be on the
 same computer or distributed over a network. Communication between
 devices uses CORBA and can be synchronous, asynchronous or event driven.
 .
 The object model in TANGO supports methods, attributes and properties.
 TANGO provides an API which hides all the details of network access and
 provides object browsing, discovery, and security features. Permanent
 data is stored in a MySQL/MariaDB database.
 .
 TANGO is being actively developed as a collaborative effort between the
 ESRF (www.esrf.eu), Soleil (synchrotron-soleil.fr), Alba (www.cells.es),
 and Elettra institutes (www.elettra.trieste.it).
 .
 This package contains the documentation for the libtango9-4 library.

Package: libtango-tools
Architecture: any
Section: net
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - common executable files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure.

Package: tango-common
Architecture: all
Multi-Arch: foreign
Section: net
Depends: adduser, ${misc:Depends}
Description: TANGO distributed control system - common files
 This package provides shared files for the TANGO distributed control
 system, and sets up the required infrastructure. It is for now an
 empty package

Package: tango-db
Architecture: any
Section: net
Depends: dbconfig-mysql | dbconfig-no-thanks,
         libtango-tools,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: default-mysql-client
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - database server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO database server using MySQL/MariaDB.

Package: tango-starter
Architecture: any
Section: net
Depends: libtango-tools, ${misc:Depends}, ${shlibs:Depends}
# omninotify is not packaged in debian
# There is an archived RFP: https://bugs.debian.org/134449
#Suggests: omninotify
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - starter server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device control server. It can start, stop,
 or report the status of other TANGO components.

Package: tango-accesscontrol
Architecture: any
Section: net
Depends: libtango-tools,
         tango-db,
         tango-starter,
         ${misc:Depends},
         ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: TANGO distributed control system - accesscontrol server
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO accesscontrol server. It can be used to
 manage the users and IP addresses that are permitted to access TANGO
 devices.

Package: tango-test
Architecture: any
Section: net
Depends: tango-starter, ${misc:Depends}, ${shlibs:Depends}
Description: TANGO distributed control system - test device
 TANGO is an object oriented distributed control system. It allows
 communication between TANGO device processes running on the same
 computer or distributed over the network. These processes can
 provide services to the control system all over the network, such as
 hardware control or data processing.
 .
 This package provides a TANGO device which implements all TANGO
 attribute types, and can be used for testing the installation.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk

export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_LDFLAGS_MAINT_STRIP = -Wl,-Bsymbolic-functions

CONFIGURE_OPTS :=	-DCMAKE_BUILD_TYPE=Release \
					-DTANGO_OMNI_BASE=/usr \
					-DTSD_JAVA=OFF \
					-DTDB_DATABASE_SCHEMA=OFF \
					-DDB_SCRIPTS=ON \
					-DTSD_TAC=ON

# TODO: handle/remove --disable-jpegmmx

# sphinxdoc is available only when building the arch-all packages
WITH_SPHINXDOC = $(shell if [ -x /usr/bin/dh_sphinxdoc ]; then echo "--with sphinxdoc"; fi)

%:
	dh $@ $(WITH_SPHINXDOC)

# TODO: migrate this target to support cmake
# for trixie (with tango 9.4), this is not super imporant, since 9.3 and 9.4 DBs are compatible
sql:
	dh_auto_configure -- $(CONFIGURE_OPTS)
	# use this target to generate the dbconfig-common upgrade script once the debian/changelog is ok
	cp cppserver/database/update_db_from_9.2.5_to_9.3.4.sql debian/dbconfig-common/data/tango-db/upgrade/mysql/$(DEB_VERSION_UPSTREAM)
	$(MAKE) distclean

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_OPTS)

override_dh_auto_build-indep:
	$(MAKE) -C doc/src/ html

override_dh_auto_install-arch:
	dh_auto_install --destdir="$(CURDIR)/debian/tmp/"
	# install dbconfig-common scripts
	install -d debian/tmp/usr/share/dbconfig-common/data/tango-db/install
	install -p -m 644 debian/tmp/usr/share/tango/db/create_db.sql debian/tmp/usr/share/dbconfig-common/data/tango-db/install/mysql
	install -d debian/tmp/usr/share/
	cp -r debian/dbconfig-common debian/tmp/usr/share
	install -d debian/tmp/usr/lib/tango
	cp debian/tango-starter-register-helper debian/tmp/usr/lib/tango

	# install scripts used during the configuration
	install -d debian/tmp/usr/share/tango-db

override_dh_auto_install-indep:
	# move the built documentation before installing
	# TODO: why?
	-cp -r doc/src/build/html doc/
	install -d debian/tmp/usr/share/doc/tango
	install -d debian/tmp/usr/share/doc/tango/idl/
	-cp -r doc/html debian/tmp/usr/share/doc/tango/

	# install the tango home dir
	install -d debian/tmp/var/lib/tango

override_dh_install:
	# libtango9-4
	dh_install -p libtango9-4 usr/lib/*/libtango.so.*

	# libtango-dev
	dh_install -p libtango-dev usr/include/tango/*
	dh_install -p libtango-dev usr/include/tango/idl
	dh_install -p libtango-dev usr/include/tango.idl usr/include/tango/idl/
	dh_install -p libtango-dev usr/lib/*/libtango*.so
	dh_install -p libtango-dev usr/lib/*/pkgconfig/tango.pc
	dh_install -p libtango-dev usr/lib/*/pkgconfig/tangoidl.pc

	# libtango-doc
	dh_install -p libtango-doc usr/share/doc/tango/html
	dh_install -p libtango-doc usr/share/doc/tango

	# libtango-tools
	dh_install -p libtango-tools usr/bin/tango_admin usr/bin

	# tango-common
	dh_install -p tango-common var/lib/tango

	# tango-db
	dh_install -p tango-db usr/bin/Databaseds usr/lib/tango
	dh_install -p tango-db usr/share/tango-db
	dh_install -p tango-db usr/share/dbconfig-common
	dh_install -p tango-db usr/share/tango/db/create_db_tables.sql usr/share/tango-db/
	dh_install -p tango-db usr/share/tango/db/stored_proc.sql usr/share/tango-db/
	dh_install -p tango-db usr/share/tango/db/my.cnf usr/share/tango-db/

	# tango-starter
	dh_install -p tango-starter usr/bin/Starter usr/lib/tango
	dh_install -p tango-starter usr/lib/tango/tango-starter-register-helper usr/lib/tango/

	# tango-accesscontrol
	dh_install -p tango-accesscontrol usr/bin/TangoAccessControl usr/lib/tango
	# TODO: ship this? (if yes, need to be removed from debian/not-installed
	# dh_install -p tango-accesscontrol usr/bin/tango_wpa

	# tango-test
	dh_install -p tango-test usr/bin/TangoTest usr/lib/tango

	dh_install -X.la

override_dh_installinit:
	# the tango-accesscontrol device must be started after the tango-db.
	dh_installinit -ptango-accesscontrol --update-rcd-params="defaults 25"
	# the tango-starter device must be started after the tango-db and the tango-accesscontrol.
	dh_installinit -ptango-starter --update-rcd-params="defaults 30"
	dh_installinit -a -Ntango-accesscontrol -Ntango-starter

# Aucun test nécessaire pour la documentation
override_dh_auto_test-indep:
